<?php
class Service_WikiPatterns extends XcBase {

    var $_kernel;

    function Service_WikiPatterns($kernelLink) {
           $this->_localname = 'WikiPatterns';
           $this->XcBase($kernelLink);
           $this->_kernel = $this->srvMainKernel();
           $this->advOnto = $this->_kernel->srvFactory("AdvOntology");
    }

    function onInstall($params) {
           if(!$this->advOnto->typeExists("Page")) {
              $this->advOnto->addType("Page", "int(11)");
           }

           $this->advOnto->addType("WikiPattern", "varchar(50)",true);
           $this->advOnto->addTypeField("WikiPattern", "name", "varchar(50)");
           $this->advOnto->addTypeField("WikiPattern", "tplfile", "varchar(50)");

           $this->advOnto->addLinkType(array("Page", "WikiPattern"), "PageWikiPattern");
         /*
         $this->_db->Query("CREATE TABLE `".$this->_db->config["table_prefix"]."wtp_patterns` (
           `id` tinyint(4) NOT NULL auto_increment,
           `name` varchar(30) NOT NULL default '',
           `tplfile` varchar(50) NOT NULL default '',
           PRIMARY KEY  (`id`)
         ) ENGINE=MyISAM");
         */
         /*
         $this->_db->Query("CREATE TABLE `".$this->_db->config["table_prefix"]."wtp_pages` (
           `pageid` int(11) NOT NULL default '0',
           `fieldid` int(11) NOT NULL default '0',
           `value` text NOT NULL,
           PRIMARY KEY  (`pageid`,`fieldid`)
         ) ENGINE=MyISAM");
         */
         $this->_db->Query("CREATE TABLE `".$this->_db->config["table_prefix"]."wtp_scheme` (
           `id` int(11) NOT NULL auto_increment,
           `patternid` tinyint(4) NOT NULL default '0',
           `name` varchar(40) NOT NULL default '',
           `description` varchar(200) NOT NULL default '',
           `type` text NOT NULL default '',
           `defaultval` varchar(250) NOT NULL default '',
           PRIMARY KEY  (`id`)
         ) ENGINE=MyISAM");


           return true;
    }

    function onUninstall($params) {
           $res = $this->advOnto->getAllConcepts("WikiPattern");

           foreach($res as $wp) {
             $this->advOnto->delType("wp".$wp["data"]);
           }

           $this->advOnto->delType("WikiPattern");
           $this->advOnto->delLinkType("PageWikiPattern");

           //$this->_db->Query("DROP TABLE `".$this->_db->config["table_prefix"]."wtp_patterns`");
           //$this->_db->Query("DROP TABLE `".$this->_db->config["table_prefix"]."wtp_pages`");
           $this->_db->Query("DROP TABLE `".$this->_db->config["table_prefix"]."wtp_scheme`");

           return false;
    }

    function getPatternName($pageid) {
       $servOnto = $this->_kernel->srvFactory("AdvOntology");

       $pageontoid = $servOnto->getConceptIdByData("Page", $pageid);

       $link = $servOnto->getLinkByConceptIds("PageWikiPattern", array("Page1" => $pageontoid));

       $patres = $servOnto->getConcept("WikiPattern", $link["WikiPattern1"]);

       return $patres["data"];
    }

    function savePageData($pageid, $data) {
       $servOnto = $this->_kernel->srvFactory("AdvOntology");

       $patName = $this->getPatternName($pageid);

       $pagePatId = $servOnto->getConceptIdByData("wp".$patName, $pageid);

       $servOnto->setConcept("wp".$patName, $pagePatId, $pageid, null, $data);
    }

    function getPageDataPattern($pattern, $pageid) {
        $data = $this->advOnto->getConceptByData("wp".$pattern, $pageid);
        return $data;
    }

    function getPageData($pageid) {
       return $this->getPageDataPattern($this->getPatternName($pageid),$pageid);
    }

    function advOnto_del_Page($params) {
       $pgidRec = $this->advOnto->getConcept("Page", $params["id"]);
       Wptrn_RemovePagePatternValues($this->_kernel,$pgidRec["data"]);
       return "";
    }

    function BatchImport($basepath, $pattern, $xml) {

       //    
       $resPtn = Wptrn_TplByName($this->_kernel,$pattern);
       $ptnFields = $this->_kernel->LoadAll('SELECT * FROM '.$this->_kernel->config["table_prefix"]."wtp_scheme WHERE patternid='".quote($resPtn["id"])."' ORDER BY id ASC");

       foreach($xml->doc as $dataXml) {
         $data = get_object_vars($dataXml);

         foreach($data as $key=>$value) {
            $data[$key] = iconv("UTF-8", $this->lang["charset"], $value);
         }
         /*
         $curPattern = iconv("UTF-8", $this->lang["charset"], $data["pattern"]);
         echo $curPattern."<br />";
         */

         //  
         $newPageTag = $basepath.'/'.str_replace(' ',"-",$data["pagetag"]);
         $this->_kernel->SavePage($newPageTag,'=='.$data["pagetag"].'==');
         //   -     
         //$this->_kernel->LoadPage($newPageTag, '', LOAD_NOCACHE);
         $this->_kernel->pageCache = array();
         $this->_kernel->wantedCache[$this->_kernel->language["code"]] = array();


         //  
         $pgid = $this->_kernel->LoadIdByTag($newPageTag);
         Wptrn_AttachPatternByName($this->_kernel, $pgid, $pattern);

         //    XML
         $req = array();
         foreach($ptnFields as $field) {
            $req[$field["name"]] = $data[$field["name"]];
         }

         //  
         $this->savePageData($pgid, $req);
         $body = Wptrn_ProcPage($this->_kernel,$resPtn["tplfile"],'one',$pgid);
         $body_r = $this->_kernel->SavePage($newPageTag,$body,'');

        // now we render it internally so we can write the updated link table.
        $this->_kernel->ClearLinkTable();
        $this->_kernel->StartLinkTracking();
        $dummy = $this->_kernel->Format($body_r, "post_wacko");
        $this->_kernel->StopLinkTracking();
        $this->_kernel->WriteLinkTable();
        $this->_kernel->ClearLinkTable();

        //    
        // ....     -  

       }
    }

}
?>