<?php

/**
*      .     REMOVEPAGE    
*    .
* @param $mythis   $this
* @param $pageid ID ,    .
*/

function Wptrn_RemovePagePatternValues($mythis,$pageid) {
  //$mythis->Query('DELETE FROM '.$mythis->config["table_prefix"]."wtp_pages WHERE pageid='".quote($pageid)."'");
  $servWP = $mythis->srvFactory("WikiPatterns");
  $servOnto = $mythis->srvFactory("AdvOntology");
  if($ptname = $servWP->getPatternName($pageid)) {
     $locid = $servOnto->getConceptIdByData("wp".$ptname,$pageid);
     $servOnto->delConcept("wp".$ptname, $locid);

     $pageontoid = $servOnto->getConceptIdByData("Page", $pageid);
     $linkres = $servOnto->getLinkByConceptIds("PageWikiPattern", array("Page1" => $pageontoid));
     $servOnto->delLink("PageWikiPattern", $linkres["id"]);
  }
}

/**
*    ID.    ;   scheme.         .
* @param $mythis   $this
* @param $ptnid ID 
*/

function Wptrn_RemovePatternById($mythis,$ptnid) {
  $servOnto = $mythis->srvFactory("AdvOntology");

  $res = $mythis->LoadAll('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_scheme WHERE patternid='".quote($ptnid)."'");

  $res1 = $servOnto->getConcept("WikiPattern",$ptnid);
  foreach($res as $attr) {
    Wptrn_RemoveAttrById($mythis,$attr["id"]);
  }
  $servOnto->delType("wp".$res1["name"]);
  //     
  $links = $servOnto->getLinksByConceptIds("PageWikiPattern", array("WikiPattern1" => $ptnid));
  $linksId = $servOnto->utilDBtoIDS($links);
  $servOnto->delConcepts("linkPageWikiPattern", $linksId);
  $servOnto->delConcept("WikiPattern", $ptnid);
  //$mythis->Query('DELETE FROM '.$mythis->config["table_prefix"]."wtp_patterns WHERE id='".quote($ptnid)."'");
}

/**
*     ID.        .
* @param $mythis   $this
* @param $attid ID 
*/

function Wptrn_RemoveAttrById($mythis,$attid) {
   $mythis->Query('DELETE FROM '.$mythis->config["table_prefix"]."wtp_scheme WHERE id='".quote($attid)."'");
   //$mythis->Query('DELETE FROM '.$mythis->config["table_prefix"]."wtp_pages WHERE fieldid='".quote($attid)."'");
}

function Wptrn_InstallPattern($mythis,$name,$tplfile,$fields) {
   $servOnto = $mythis->srvFactory("AdvOntology");

   //$mythis->Query("INSERT INTO ".$mythis->config["table_prefix"]."wtp_patterns SET name='".quote($name)."', tplfile='".quote($tplfile)."'");
   $patontoid = $servOnto->addConcept("WikiPattern", $name, null, compact("name", "tplfile"));
   $servOnto->addType("wp".$name,"int(11)");

   //$res = $mythis->LoadSingle("SELECT * FROM ".$mythis->config["table_prefix"]."wtp_patterns WHERE name='".quote($name)."'");
   foreach($fields as $field) {
     $mythis->Query("INSERT INTO ".$mythis->config["table_prefix"]."wtp_scheme SET ".
                     "patternid='".quote($patontoid)."', ".
                     "name='".quote($field['name'])."', ".
                     "description='".quote($field['description'])."', ".
                     "type='".quote($field['type'])."', ".
                     "defaultval='".quote($field['default'])."'");
     $servOnto->addTypeField("wp".$name, $field["name"]);
   }

}


/**
*     .   ,  .
* @param $mythis   $this
* @param $pageid ID ,    .
* @param $ptrnid ID 
* @see Wptrn_AttachPatternByName
*/

function Wptrn_AttachPatternByID($mythis,$pageid,$ptrnid) {
  $servOnto = $mythis->srvFactory("AdvOntology");

  Wptrn_RemovePagePatternValues($mythis,$pageid);

  //$res1 = $mythis->LoadSingle('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_patterns WHERE id='".quote($ptrnid)."'");
  $res1 = $servOnto->getConcept("WikiPattern",$ptrnid);
  $res = $mythis->LoadAll('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_scheme WHERE patternid = '".quote($ptrnid)."'");

  $pgontoid = $servOnto->addConceptIfNotExists("Page", $pageid);
  $patontoid = $servOnto->getConceptIdByData("WikiPattern", $res1["name"]);
  $req = array();
  foreach($res as $field) {
    //$mythis->Query('INSERT INTO '.$mythis->config["table_prefix"]."wtp_pages SET pageid='".quote($pageid)."', fieldid='".quote($field["id"])."', value='".quote($field["defaultval"])."'");
    $req[$field["name"]] = $field["defaultval"];
  }
  $servOnto->addConcept("wp".$res1["name"], $pageid, null, $req);
  $servOnto->addLink("PageWikiPattern", array("Page1" => $pgontoid, "WikiPattern1" => $patontoid));
}

/**
*     .   ,  .
* @param $mythis   $this
* @param $pageid ID ,    .
* @param $name  
* @see Wptrn_AttachPatternByID
*/

function Wptrn_AttachPatternByName($mythis,$pageid,$name) {
  //$res = $mythis->LoadSingle('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_patterns WHERE name = '".quote($name)."'");
  $servOnto = $mythis->srvFactory("AdvOntology");
  $res = $servOnto->getConceptByData("WikiPattern",$name);
  if($res!="") {
      Wptrn_AttachPatternByID($mythis,$pageid,$res["id"]);
  }
}

/**
*     ,   .
* @param $mythis   $this
* @param $pageid ID 
* @param $pagetag  
* @param $text  
* @return   .
*/
/*
function Wptrn_ProcessForPage($mythis,$pageid,$pagetag,$text) {
  $res = $mythis->LoadAll('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_pages as pgs, ".$mythis->config["table_prefix"]."wtp_scheme as scheme WHERE pgs.pageid='".quote($pageid)."' AND pgs.fieldid = scheme.id");
  if($res == array()) return false;
  $fp = fopen('extensions/WikiPatterns/smarty/templates/tmp.tpl','w');
  fwrite($fp,$text);
  fclose($fp);

  $sm = Wptrn_NewSmarty($mythis);
  $sm->assign('tag',$pagetag);

  foreach($res as $field) {
        $sm->assign($field["name"],$field["value"]);
  }
  return $sm->fetch('tmp.tpl');
}
*/
/**
*     Smarty,     .
* @param $mythis   $this
* @return    .
*/

function Wptrn_NewSmarty($mythis) {
  $sm = $mythis->NewSmarty();
  //$def = str_replace("\\","/",getcwd()).'/extensions/WikiPatterns/smarty/';
  $def = $mythis->getSiteDataPath().'data/WikiPatterns/';
  $sm->template_dir = $def.'templates/';
  $sm->compile_dir = $def.'templates_c/';
  $sm->config_dir = $def.'config/';
  $sm->cache_dir = $def.'cache/';
  $sm->plugins_dir[] = $def.'plugins/';
  //$sm->php_handling = SMARTY_PHP_ALLOW;
  //$sm->left_delimiter = '{-';
  //$sm->right_delimiter = '-}';
  return $sm;
}

function Wptrn_ProcPage($mythis,$template,$ext,$pageid) {
  if(!$mythis->symSome($template,'A-Za-z0-9_')) return 'Incorrect template '.htmlspecialchars($template);
  if(!$mythis->symSome($ext,'A-Za-z0-9_.')) return 'Incorrect extension '.htmlspecialchars($ext);

  $sm = Wptrn_NewSmarty($mythis);
  $data = Wptrn_LoadPageData($mythis,$pageid);
  $sm->assign('data',$data);
  $page = $mythis->LoadSingle("select * from ".$mythis->config["table_prefix"]."pages where id = '".quote($pageid)."' limit 1");
  $page["supertag"] = str_replace("_","'",$page["supertag"]);
  $page["pretag"] = substr($page["tag"],0,strrpos($page["tag"],"/"));
  $page["prename"] = $mythis->AddSimpleSpaces(substr($page["pretag"],strrpos($page["pretag"],"/")+1));
  $sm->assign('page',$page);
  $sm->assign('system',Wptrn_PrepareSystemData($mythis));

  $fname = $mythis->getSiteDataPath()."data/WikiPatterns/templates/".$template."/lang/".$mythis->DetermineLang().".php";
  if(file_exists($fname)) {
    include($fname);
    $sm->assign('lang',$lang_ptn);
  }
  return $sm->fetch($template.'/'.$ext.'.txt');
}

function Wptrn_LoadPageData($mythis,$pageid) {
  $servWP = $mythis->srvFactory("WikiPatterns");
  return $servWP->getPageData($pageid);
}

function Wptrn_ProcPages($mythis,$template,$ext,&$pages) {
  if(!$mythis->symSome($template,'A-Za-z0-9_')) return 'Incorrect template '.htmlspecialchars($template);
  if(!$mythis->symSome($ext,'A-Za-z0-9_.')) return 'Incorrect extension '.htmlspecialchars($ext);
  foreach($pages as $key => $page){
            $pages[$key]['pretag'] = substr($pages[$key]["tag"],0,strrpos($pages[$key]["tag"],"/"));
            $pages[$key]['prename'] = $mythis->AddSimpleSpaces(substr($pages[$key]["pretag"],strrpos($pages[$key]["pretag"],"/")+1));
            $pages[$key]['supertag'] = str_replace("_","'",$pages[$key]['supertag']);
  }
  $sm = Wptrn_NewSmarty($mythis);
  $sm->assign('pages',&$pages);
  $sm->assign('system',Wptrn_PrepareSystemData($mythis));

  $fname = $mythis->getSiteDataPath()."data/WikiPatterns/templates/".$template."/lang/".$mythis->DetermineLang().".php";
  if(file_exists($fname)) {
    include($fname);
    $sm->assign('lang',$lang_ptn);
  }

  return $sm->fetch($template.'/'.$ext.'.txt');
}

/**
*    ,     .
* @param $mythis   $this
* @param $str  
* @return   ,     ;    .
*/

function Wptrn_TplByName($mythis,$name) {
  $servOnto = $mythis->srvFactory("AdvOntology");
  $res = $servOnto->getConceptByData("WikiPattern",$name);
  return $res;
}

/**
*    ,        .
* @param $mythis   $this
* @param $tplid ID .
* @param $str  
* @return   ,        .
*/

function Wptrn_FieldByName($mythis,$tplid,$str) {
  return $mythis->LoadSingle('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_scheme WHERE name='".quote($str)."' AND patternid='".quote($tplid)."'");
}

function Wptrn_IsPageTemplated($mythis,$pageid) {
/*
  $res = $mythis->LoadAll('SELECT * FROM '.$mythis->config["table_prefix"]."wtp_pages as pgs, ".$mythis->config["table_prefix"]."wtp_scheme as scheme WHERE pgs.pageid='".quote($pageid)."' AND pgs.fieldid = scheme.id");
  return $res != array();
*/
  $servOnto = $mythis->srvFactory("AdvOntology");
  $pageontoid = $servOnto->getConceptIdByData("Page", $pageid);
  $link = $servOnto->getLinkByConceptIds("PageWikiPattern", array("Page1" => $pageontoid));
  return $link!="";
  //return $res[
}

function Wptrn_PrepareSystemData($mythis) {
  return array(
    'rooturl' => $mythis->GetConfigValue("root_url"),
    'themeurl' => $mythis->GetConfigValue("theme_url"),
  );
}

function Wptrn_Diff($myhis,$a,$b) {
  $bodyA = explode("\n", $a);
  $bodyB = explode("\n", $b);

  $res = array();

  $res["added"] = implode("\n",array_diff($bodyA, $bodyB));
  $res["deleted"] = implode("\n",array_diff($bodyB, $bodyA));

  return $res;

}

?>